package com.poc.repository;

import java.util.List;

import org.bson.Document;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.data.mongodb.core.query.Update;
import org.springframework.stereotype.Repository;

import com.mongodb.client.result.UpdateResult;
import com.poc.entity.Employee;
@Repository
public class EmpRepositoryImpl implements EmpRepository {
	private static final Logger logger = LoggerFactory.getLogger(EmpRepositoryImpl.class);
	@Autowired
	private MongoTemplate mongoTemplate;

	@Override
	public List<Employee> findAll() {
		return mongoTemplate.findAll(Employee.class);
	}

	@Override
	public Employee findById(String id) {
		Query query = new Query();
		query.addCriteria(Criteria.where("emp_id").is(id));
		return mongoTemplate.findOne(query, Employee.class);
	}

	@Override
	public Employee save(Employee e) {
		return mongoTemplate.save(e);
	}

	@Override
	public void saveOrUpdate(Employee e) {
	    Query query = new Query();
	    query.addCriteria(Criteria.where("emp_id").is(e.getEmpId()));

	    Document doc = new Document();
	    mongoTemplate.getConverter().write(e, doc);
	    Update update = Update.fromDocument(doc);

	    UpdateResult result=mongoTemplate.upsert(query, update, Employee.class);
	    result.getMatchedCount();
	    logger.info("Matched Count:{},{}",result.getMatchedCount(),e.getEmpId());
	}

	
}
